package com.xyhy.chargpilemqttcluster;

import com.xyhy.chargpilemqttcluster.common.Common;
import com.xyhy.chargpilemqttcluster.common.disruptor.DisruptorCommon;
import com.xyhy.chargpilemqttcluster.common.mqtt.MqttServer;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.listening.Listen_addOrder;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.listening.Listen_settlement;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.listening.Listen_startCp;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.listening.Listen_stopCp;
import com.xyhy.chargpilemqttcluster.common.redis.JedisPoolUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import redis.clients.jedis.Jedis;

@Component
public class ServerRun extends Common implements CommandLineRunner {

    @Override
    public void run(String... args) throws Exception {

        //redis启动监听
        Jedis jds = JedisPoolUtils.getInstance().getConnection() ;
        if (jds!=null){
            log.info("Redis 连接预热成功！");
        }
        jds.close();

        //业务队列监听启动
        DisruptorCommon.getDisruptorCommon().Start();

        Listen_addOrder la = new Listen_addOrder();
        la.start();

        Listen_settlement ls = new Listen_settlement();
        ls.start();

        Listen_startCp ls_start = new Listen_startCp();
        ls_start.start();

        Listen_stopCp ls_stop = new Listen_stopCp();
        ls_stop.start();


        //MQTT server 启动
        MqttServer.getInstance().connect();

    }
}
