package com.xyhy.chargpilemqttcluster.common.disruptor;

import com.lmax.disruptor.dsl.Disruptor;
import com.lmax.disruptor.util.DaemonThreadFactory;
import com.xyhy.chargpilemqttcluster.common.Common;

public class DisruptorCommon extends Common {

    private static DisruptorCommon _dis;

    public static DisruptorCommon getDisruptorCommon()
    {
        if (_dis == null)
        {
            _dis = new DisruptorCommon();
        }
        return _dis;
    }

    private Disruptor<LongEvent> _disruptor;

    public Disruptor<LongEvent> getDisruptor()
    {
        if (_disruptor==null)
        {
            Start();

        }
        return _disruptor;
    }


    public void Start() {
        LongEventFactory factory = new LongEventFactory();

        // Specify the size of the ring buffer, must be power of 2.
        int bufferSize = 1024;

        // Construct the Disruptor
        _disruptor = new Disruptor<>(factory, bufferSize, DaemonThreadFactory.INSTANCE);

        // Connect the handler
        _disruptor.handleEventsWith(new LongEventHandler());

        // Start the Disruptor, starts all threads running
        _disruptor.start();

        log.info("业务队列启动成功............");


    }

}
