package com.xyhy.chargpilemqttcluster.common.disruptor;

import com.lmax.disruptor.RingBuffer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class LongEventProducer {

    public final Logger log =  LoggerFactory.getLogger(this.getClass());

    private RingBuffer<LongEvent> ringBuffer;

    public LongEventProducer(RingBuffer<LongEvent> ringBuffer) {
        this.ringBuffer = ringBuffer;
    }

    public void onData(byte[] byteBuffer, String topic) {
        // 获取事件队列的下表位置
        long sequence = ringBuffer.next();
        try {
            // 取出空队列
            LongEvent longEvent = ringBuffer.get(sequence);
            // 给空队列赋值
            longEvent.set(byteBuffer,topic);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {

            ringBuffer.publish(sequence);
        }

    }


}
