package com.xyhy.chargpilemqttcluster.common.mqtt;

import com.lmax.disruptor.RingBuffer;
import com.xyhy.chargpilemqttcluster.common.Common;
import com.xyhy.chargpilemqttcluster.common.disruptor.DisruptorCommon;
import com.xyhy.chargpilemqttcluster.common.disruptor.LongEvent;
import com.xyhy.chargpilemqttcluster.common.disruptor.LongEventProducer;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.stereotype.Component;

@Component
public class MqttGetMessage extends Common implements MqttCallback {

    @Override
    public void connectionLost(Throwable throwable) {
        log.error("MQTT连接已经断开！");
        //MqttServer.getInstance().reConnect();
    }

    @Override
    public void messageArrived(String topic, MqttMessage mqttMessage) throws Exception {
        RingBuffer<LongEvent> ringBuffer = DisruptorCommon.getDisruptorCommon().getDisruptor().getRingBuffer();

        // 8.创建生产者
        LongEventProducer longEventProducer = new LongEventProducer(ringBuffer);

        longEventProducer.onData(mqttMessage.getPayload(),topic);
    }

    @Override
    public void deliveryComplete(IMqttDeliveryToken iMqttDeliveryToken) {

    }
}
