package com.xyhy.chargpilemqttcluster.common.rabbitmq.listening;

import com.alibaba.fastjson.JSON;
import com.rabbitmq.client.*;
import com.xyhy.chargpilemqttcluster.common.Common;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.RabbitUtils;
import com.xyhy.chargpilemqttcluster.workThread.message.back.MessageBackThreadGroupCommon;
import com.xyhy.chargpilemqttcluster.workThread.message.back.Message_startCP;
import com.xyhy.chargpilemqttcluster.workThread.message.back.Message_stopCP;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;

public class Listen_stopCp {

    public final Logger log =  LoggerFactory.getLogger(this.getClass());

    public void start()
    {

        String exchangeName = Common.getConfigByName("rabbitMq.server.TOMQTTSERVEREXCHANGE");
        String queueName = "mqtt."+Common.FUNCTION_STOPCP;
        String Topic = queueName;

        try {
            Channel channel =  RabbitUtils.getChannel();
            channel.exchangeDeclare(exchangeName, "topic",true);
            channel.queueDeclare(queueName,true,false,false,null);
            channel.queueBind(queueName,exchangeName,Topic);

            Consumer consumer = new DefaultConsumer(channel) {
                @Override
                public void handleDelivery(String consumerTag, Envelope envelope, AMQP.BasicProperties properties,
                                           byte[] body) throws IOException {
                    String message = new String(body, "UTF-8");
                    Message_stopCP work = new Message_stopCP();
                    work.setOb(JSON.parseObject(message));
                    MessageBackThreadGroupCommon.getThreadGroupCom().getWorkThreadPool().execute(work);
                }
            };
            // channel绑定队列、消费者，autoAck为true表示一旦收到消息则自动回复确认消息
            channel.basicConsume(queueName, true, consumer);
            log.info("返回停止充电桩开始监听.....");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
