package com.xyhy.chargpilemqttcluster.common.rabbitmq.publish;

import com.rabbitmq.client.Channel;
import com.xyhy.chargpilemqttcluster.common.Common;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.RabbitUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class Publish_common extends Common {

    public Channel _channel;

    public String _exchangeName;
    public String _queueName;
    public String _topic;

    public final Logger log =  LoggerFactory.getLogger(this.getClass());

    public Channel getChannel(String exchangeName,String queueName,String topic)
    {
        return getChannelByTTL(exchangeName,queueName,topic,0);
    }

    public Channel getChannelByTTL(String exchangeName,String queueName,String topic,int TTL)
    {

        if (_channel == null)
        {
            Channel channel =  RabbitUtils.getChannel();
            try {
                channel.exchangeDeclare(exchangeName, "topic");
                if (TTL>0)
                {
                    Map<String,Object> arguments = new HashMap<String, Object>();
                    arguments.put("x-message-ttl",TTL);
                    channel.queueDeclare(queueName,true,false,false,arguments);
                }else{
                    channel.queueDeclare(queueName,true,false,false,null);
                }
                channel.queueBind(queueName,exchangeName,topic);
                _channel = channel;
            } catch (IOException e) {
                e.printStackTrace();
                return null;
            }
        }
        return _channel;
    }

    public void sendMessage(String message)
    {
        log.info("SendToServer ExchangeName："+_exchangeName+" Topic："+_topic+" Body:"+message);
        try {
            _channel.basicPublish(_exchangeName, _topic, null,message.getBytes("UTF-8"));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
