package com.xyhy.chargpilemqttcluster.workThread.message;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xyhy.chargpilemqttcluster.common.mqtt.MqttServer;
import com.xyhy.chargpilemqttcluster.common.rabbitmq.publish.*;
import com.xyhy.chargpilemqttcluster.common.redis.RedisHelp;

import java.text.SimpleDateFormat;

public class MessageBus extends MessageCommon{

    public void Message_101(JSONObject cmd){
        String devId = cmd.getString("devId");
        String devType = cmd.getString("devType");
        RedisHelp.setDeviceVulue(devId,ONLINE);
        String sendtopic = "toclient/"+devType+"/"+devId;
        JSONObject returnObj = getSUCCESSResult(102);
        MqttServer.getInstance().pushlish(sendtopic,returnObj.toJSONString());
    }   

    public void Message_103(JSONObject cmd){
        log.info(cmd.toJSONString());
    }


    public void Message_201(JSONObject cmd){
        JSONObject obj =null;
        int devType = cmd.getInteger("devType");
        switch (devType){
            case 4:
                obj = getRTDevType3(cmd);
                //Publish_saveRealTime_Tricycle.getInstence().sendMessage(obj.toJSONString());
                break;
        }

        JSONArray arr_Bettey = getRTBettey(cmd);
        if (arr_Bettey!=null && arr_Bettey.size()>0){
            Publish_saveRealTime_LowBattery.getInstence().sendMessage(arr_Bettey.toJSONString());
        }

    }

    public void Message_302(JSONObject cmd){

       String devId = cmd.getString("devId");
       String intId = cmd.getString("intId");
       String orderId = cmd.getString("orderId");
       int resultCode = cmd.getIntValue("resultCode");

       if (resultCode == 1){

           String obj = RedisHelp.getOrderCheckVulue(devId+"-"+intId+"-"+orderId);
           JSONObject returnOBj = JSONObject.parseObject(obj);
           returnOBj.put("step","success");
           RedisHelp.setOrderCheckVulue(devId+"-"+intId+"-"+orderId,returnOBj.toJSONString());

       }else{

       }
    }

    public void Message_303(JSONObject cmd){




    }

    public void Message_305(JSONObject cmd){

        String devId = cmd.getString("devId");
        String intId = cmd.getString("intId");
        String orderId = cmd.getString("orderId");
        int resultCode = cmd.getIntValue("resultCode");

        if (resultCode == 1){

            String obj = RedisHelp.getOrderCheckVulue(devId+"-"+intId+"-"+orderId);
            JSONObject returnOBj = JSONObject.parseObject(obj);
            returnOBj.put("step","success");
            RedisHelp.setOrderCheckVulue(devId+"-"+intId+"-"+orderId,returnOBj.toJSONString());

        }else{

        }
    }


    public void Message_309(JSONObject cmd){

        JSONObject body = new JSONObject();
        body.put("chargPileId",cmd.getString("devId")+""+cmd.getString("intId"));
        body.put("chargnumber",cmd.getString("startdeviceid"));
        Publish_addOrder.getInstence().sendMessage(body.toJSONString());

    }

    public void Message_401(JSONObject cmd){

        JSONObject obj = new JSONObject();
        if (cmd.getString("js002").equals("01"))//账号
        {
            obj.put("userId",cmd.getString("js003"));
        }else{ //卡
            obj.put("chargnumber",cmd.getString("js003"));
        }

        obj.put("userType",cmd.getString("js002"));

        obj.put("chargPileId",cmd.getString("devId")+cmd.getString("js000"));
        obj.put("orderid",cmd.getString("js001"));

        obj.put("chargstarttime",cmd.getString("js006"));
        obj.put("chargendtime",cmd.getString("js007"));
        obj.put("sharpChargPower",cmd.getDoubleValue("js008"));
        obj.put("peakChargPower",cmd.getDoubleValue("js010"));
        obj.put("flatChargPower",cmd.getDoubleValue("js012"));
        obj.put("valleyChargPower",cmd.getDoubleValue("js014"));
        obj.put("orderType",cmd.getString("js004"));
        obj.put("electricMeterBeginNum",cmd.getDoubleValue("js019"));
        obj.put("electricMeterEndNum",cmd.getDoubleValue("js020"));
        obj.put("chargpilelogCause",cmd.getString("js021"));
        obj.put("vinno",cmd.getString("js023"));
        obj.put("socstart",cmd.getDoubleValue("js024"));
        obj.put("socend",cmd.getDoubleValue("js025"));

        Publish_settlement.getInstence().sendMessage(obj.toJSONString());

    }

}
