package com.xyhy.chargpilemqttcluster.workThread.message.back;

import com.alibaba.fastjson.JSONObject;
import com.xyhy.chargpilemqttcluster.common.mqtt.MqttServer;
import com.xyhy.chargpilemqttcluster.common.redis.RedisHelp;
import com.xyhy.chargpilemqttcluster.workThread.Job.Job_startCheck;
import com.xyhy.chargpilemqttcluster.workThread.message.MessageCommon;


public class Message_startCP extends MessageCommon implements Runnable {

    private JSONObject ob;

    public JSONObject getOb() {
        return ob;
    }

    public void setOb(JSONObject ob) {
        this.ob = ob;
    }

    @Override
    public void run() {

        log.info("后台启动充电桩："+ob.toJSONString());


        String sendtopic = getToClientTopic(ob,"03");
        JSONObject returnObj = getSend(301);
        String cp_id = ob.getString("cp_id");
        String cp_index = ob.getString("cp_index");
        String orderId = ob.getString("order_id");
        returnObj.put("devId",cp_id);
        returnObj.put("devType",ob.getString("03"));
        returnObj.put("intId",cp_index);
        returnObj.put("orderId",orderId);
        returnObj.put("phone",ob.getString("iPhoneNo"));
        int chargMethod = ob.getIntValue("chargMethod");
        returnObj.put("chargMethod",chargMethod);
        switch (chargMethod){
            case 1:
                returnObj.put("preChargValue",ob.getDoubleValue("preChargValue"));
                break;
            case 2:
                returnObj.put("preChargTime",ob.getIntValue("preChargTime"));
                break;
            case 3:
                returnObj.put("preChargPrice",ob.getDoubleValue("preChargPrice"));
                break;
        }

        ob.put("step","starting");
        RedisHelp.setOrderCheckVulue(cp_id+"-"+cp_index+"-"+orderId,ob.toJSONString());

        MqttServer.getInstance().pushlish(sendtopic,returnObj.toJSONString());
        Job_startCheck job = new Job_startCheck();
        job.cdzid = cp_id;
        job.cdjkid = cp_index;
        job.orderId = orderId;
        job.start();

    }
}
